local class = require 'lib.middleclass'

Announce = class('Announce')

function Announce:initialize(x, y, str_color, announce_text) --originating entity
	
	self.x = x
	self.y = y
	self.timer = 2.5
	self.announce_text = announce_text or "blank"
	self.color = str_color or "white"
	self.opacity = 255
	self.scale = 2.5
	
end

function Announce:draw()
	
	self:setColor()		
	love.graphics.print(self.announce_text, self.x, self.y, 0, self.scale, self.scale)
	
end

function Announce:setColor() -- should probably accept color table, but atm this is fine.
	
	local color = self:getColor() 
	love.graphics.setColor(color.r, color.g, color.b, self.opacity) -- alpha
	
end

function Announce:getColor()

local color = {}

	if self.color == "blue" then
		color.r = 30
		color.g = 144
		color.b = 255
	elseif self.color == "red" then
		color.r = 220 
		color.g = 20
		color.b = 60
	elseif self.color == "white" then
		color.r = 255
		color.g = 255
		color.b = 255	
	elseif self.color == "gold" then
		color.r = 255
		color.g = 207
		color.b = 87
	elseif self.color == "green" then
		color.r = 25
		color.g = 255
		color.b = 25
	end

	return color
end

function Announce:update(i, dt)
			
	self.timer = self.timer - dt
	
	if self.opacity > 0 then
		self.opacity = self.opacity - 1.5
	end
	
	if self.timer <= 0 then
		self:die(i)
	end
	
end

function Announce:die(i)  -- index		
	table.remove(announcements, i)	
end


return Announce