local class = require 'lib.middleclass'

Repel = class('Repel')

function Repel:initialize(x, y, origin) --
	
	self.origin = origin
	
	self.x = x
	self.y = y
	self.radius = radius or 100 -- should be at least as large as the player ship.
	
	self.force = 1000 -- megatonnes :o
	
	self.growthtimer = 0 
	self.lifespan = 1 -- doesnt matter as long as it's not 0
	
	self.firingtimer = 0.5 -- just so they don't get wasted while you are holding the buttons
	
end

function Repel:draw(sh)
	
	love.graphics.setColor(255,207,87,30)				
	sh:draw('fill')
	
end

function Repel:update(sh, dt)
			
	self.growthtimer = self.growthtimer + dt	
	
	if self.growthtimer >= .2 then
		self:explode(sh)
	else
	
		sh:scale(1.2)-- careful with this
		
	end
		
end

function Repel:explode(sh)  	
	
	self.lifespan = 0
		
end

-- this removes the repel 'projectile' from the bullets table
-- and also removes all bullet & entities from the 'group_repel' table, so they can be repelled once more.
function Repel:die(i, sh) 
									
	Collider:remove(sh)
	sh = nil -- fix HC "shape is not registered" bug?
	table.remove(bullets, i)
	
	for i, v in ipairs(bullets) do --
		
		Collider:removeFromGroup("group_repel", v) --
				
	end
		
	for i, v in ipairs(entities) do
		
			Collider:removeFromGroup("group_repel", v) -- SHAPE IS NOT REGISTERED BUG HAPPENED HERE (before i added sh=nil above. hc shouldn't throw this error if shape reference is nil)
	
	end
	
end

function Repel:resolveCollision(sh, dx, dy)
	
	-- this thing shouldn't be affected by collision, it's the other guys that are affected.
		
end

function Repel:playSound() -- should find a good repel sound when it's working.
	if sfx.explosion:isPlaying() then
		local newSource = sfx.explosion:clone()
		newSource:play()
	else
		sfx.explosion:play()
	end
end

return Repel