-- ======================== ---
--    RANDOM HELPER FUNCTIONS	---
-- ========================	---

-- shorten 
isDown = love.keyboard.isDown
min, max = math.min, math.max
floor = math.floor

-- point contained
function point_contained(x1, y1, x2, y2, px1, py1)

	if (px1 >= x1 and px1 <= x2) then
		if (py1 >= y1 and py1 <= y2) then
			return true
		end
	end

	return false
end


-- get center of triangle from points
function triangleCenter(x1,y1,x2,y2,x3,y3)
   return (x1+x2+x3)/3,(y1+y2+y3)/3 --averaged point coordinates
end

-- Returns the angle between two points.
function math.angle(x1,y1, x2,y2) 
	return math.atan2(y2-y1, x2-x1) 
end

-- Returns the distance between two points.
function math.dist(x1,y1, x2,y2)
	return ((x2-x1)^2+(y2-y1)^2)^0.5 
end


function math.round(num, idp) -- number to be rounded, decimal precision
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

function intersects(room_a, room_b)
	local a = room_a
	local b = room_b

	return (a.x1 <= b.x2 and a.x2 >= b.x1 and
			a.y1 <= b.y2 and a.y2 >= b.y1)
end


-- HELPER FUNCTION (NOT USED)
-- gets x,y coordinate based on rotation (theta) in radians
-- i have no idea how it works....
local function rotatePoint(x, y, theta)
	local newCoords = {}

	newCoords.x = (x * math.cos(theta)) - (y * math.sin(theta));
	newCoords.y = (x * math.sin(theta)) + (y * math.cos(theta));

	return newCoords
end


-- just copied from elsewhere incase i need it (NOT USED)
--gets translated coordinates
local function getTranslatedCoords(_x1,_y1,_x2,_y2,_x3,_y3)
	local p = self.ship -- wont work as is

	local cx,cy = triangleCenter(_x1,_y1,_x2,_y2,_x3,_y3)
	
	local point1 = rotatePoint(_x1 - cx, _y1 -cy, p.shipfacing)
	local point2 = rotatePoint(_x2 -cx, _y2 -cy, p.shipfacing)
	local point3 = rotatePoint(_x3 -cx, _y3 -cy, p.shipfacing)
	
	
	local coords = {
								x1 = (p.posX + point1.x) ,
								y1 = (p.posY + point1.y) ,
								x2 = (p.posX + point2.x) ,
								y2 = (p.posY + point2.y) ,
								x3 = (p.posX + point3.x) ,
								y3 = (p.posY + point3.y) 
							}
							
	return coords
end


