local class = require 'lib.middleclass'

WeaponModifiers = class('WeaponModifiers')

function WeaponModifiers:initialize(firingspeed, lifespan, damage, firingtimer, bounces) -- since enemies dont trigger pickups, i can init these modifiers to anything for them and they will persist.

	self.fs = firingspeed and firingspeed or 0
	self.ls = lifespan and lifespand or 0
	self.dmg = damage and damage or 0 
	self.ft = firingtimer and firingtimer or 0
	self.b = bounces and bounces or 0
	
	
	--print ("INIT MODIFIERS : ", self.fs, self.ls, self.dmg, self.ft, self.b)
	
end



function WeaponModifiers:apply(weapon_type, string_prop_name) -- can i pass a string value here to access the class properties, like "dmg" then access with self["dmg"] ??? yes, yes i can.
	local pmax = {}
	local pmod = {}
	--print('apply', weapon_type, string_prop_name)
	
	if weapon_type == "bullet" then
		pmax = self:getBulletPropMax()
		pmod = self:getBulletPropStep()
	elseif weapon_type == "bomb" then
		pmax = self:getBombPropMax()
		pmod = self:getBombPropStep()
	end
	
	local prop = self[string_prop_name]
	local prop_mod = pmod[string_prop_name]
	local prop_max = pmax[string_prop_name]
	
	
	--print ('prop before ', prop)
	-- update modifier property within prop_max limit
	prop = (prop + prop_mod < prop_max and prop + prop_mod or prop_max)
	self[string_prop_name] = prop
	--print ('prop after ' , prop)
	
	--print('prop max ', prop_max)
	--print('prop step ', prop_mod)
		
end

function WeaponModifiers:getPropNames()
	local prop_names = 
			{
				"fs",
				"ls",
				"dmg",
				"ft",
				"b"
			}
			
	return prop_names
end


function WeaponModifiers:getBulletPropStep()
	local prop_step = 	
			{ 					
				fs = 50,
				ls = 0.1,
				dmg = 1,
				ft = .005,
				b = 0.1	
			}
			
	return prop_step
end

function WeaponModifiers:getBombPropStep()
	local prop_step = 	
			{ 					
				fs = 50,
				ls = 0.1,
				dmg = 25,
				ft = .1,
				b = 0.1	
			}

	return prop_step
end

function WeaponModifiers:getBulletPropMax()
	local prop_max =  
			{ 						-- bullet maximum modifer bonus
				fs = 300,
				ls = 3,
				dmg = 25,
				ft = 0.06,
				b = 5	
			}
	
	return prop_max
end

function WeaponModifiers:getBombPropMax()
	local prop_max = 
			{ 						-- bullet maximum modifer bonus
				fs = 400,
				ls = 3,
				dmg = 900,
				ft = 2.5,
				b = 3
			}

	return prop_max
end

return WeaponModifiers